;  ե
;  FileName: include.sc
;
;  version 2.3  (C) 2003, IPU/Project-Lego+Logo
;     UpDate: 1998/10/15   by T.INOMATA
;  version 2.2  (C) 1997, SIST/Project-S
;     UpDate: 1998/10/15   by T.INOMATA
;  version 2.1  (C) 1997, SIST/Project-S
;     UpDate: 1997/03/16   by H.HORIMOTO

;  version 2.0  (C) 1994, SIST/Project-S
;     Date:   1994/5/16

(define nil ())

(define (caar x) (car (car x)))
(define (cadr x) (car (cdr x)))
(define (cdar x) (cdr (car x)))
(define (cddr x) (cdr (cdr x)))
(define (caaar x) (car (car (car x))))
(define (caadr x) (car (car (cdr x))))
(define (cadar x) (car (cdr (car x))))
(define (caddr x) (car (cdr (cdr x))))
(define (cdaar x) (cdr (car (car x))))
(define (cdadr x) (cdr (car (cdr x))))
(define (cddar x) (cdr (cdr (car x))))
(define (cdddr x) (cdr (cdr (cdr x))))
(define (caaaar x) (car (car (car (car x)))))
(define (caaadr x) (car (car (car (cdr x)))))
(define (caadar x) (car (car (cdr (car x)))))
(define (caaddr x) (car (car (cdr (cdr x)))))
(define (cadaar x) (car (cdr (car (car x)))))
(define (cadadr x) (car (cdr (car (cdr x)))))
(define (caddar x) (car (cdr (cdr (car x)))))
(define (cadddr x) (car (cdr (cdr (cdr x)))))
(define (cdaaar x) (cdr (car (car (car x)))))
(define (cdaadr x) (cdr (car (car (cdr x)))))
(define (cdadar x) (cdr (car (cdr (car x)))))
(define (cdaddr x) (cdr (car (cdr (cdr x)))))
(define (cddaar x) (cdr (cdr (car (car x)))))
(define (cddadr x) (cdr (cdr (car (cdr x)))))
(define (cdddar x) (cdr (cdr (cdr (car x)))))
(define (cddddr x) (cdr (cdr (cdr (cdr x)))))

(define call/cc call-with-current-continuation)

(define (atom? x) (not (pair? x)))

;(define (not x)
;        (cond ((eq? x #f) #t) (#t #f)))
;(define (equal? a b)
;        (cond ((eqv? a b) #t)
;              ((or (atom? a)(atom? b)) #f)
;              (#t (and (equal? (car a) (car b)) (equal? (cdr a) (cdr b))))))

;(define (append2 x y)
;        (cond ((null? x) y)
;              (#t (cons (car x)(append2 (cdr x) y)))))
;(define (append . yy)
;      (cond ((null? yy) '())
;            ((null? (cdr yy)) (car yy))
;            (else (apply 'append (cons (append2 (car yy) (cadr yy)) (cddr yy))))))

(define reverse (lambda (x) (cond ((null? x) x)
                   ((null? (cdr x)) x)
                   (else (append (reverse (cdr x)) (list(car x)))))))

(define (list? x)
  (if (atom? x) (null? x) (list? (cdr x))))
(define (assoc x y)
        (cond ((null? y) #f)
        ((equal? x (caar y))(car y))
        (else (assoc x (cdr y)))))
(define (assv x y)    ; 
        (cond ((null? y) #f)
        ((eqv? x (caar y))(car y))
        (else (assv x (cdr y)))))
(define (assq x y)    ; 
        (cond ((null? y) #f)
        ((eq? x (caar y))(car y))
        (else (assq x (cdr y)))))
(define list-tail
        (lambda (x k)
                (if (zero? k)
                        x
                        (list-tail (cdr x)(- k 1)))))

(define (list-ref x k)
   (if (<= k 0) (car x) (list-ref (cdr x) (- k 1))))

(define (length-count x k)
   (if (null? x) k (length-count (cdr x) (+ k 1))))
(define (length x) (length-count x 0))

(define (member x y)
    (if (null? y) #f
      (if (equal? x (car y)) y (member x (cdr y)))))
(define (memq x y)
    (if (null? y) #f
      (if (eq? x (car y)) y (memq x (cdr y)))))
(define (memv x y)
    (if (null? y) #f
      (if (eqv? x (car y)) y (memv x (cdr y)))))

(define min (lambda (x . y)
   (if (null? y) x
     (if (> x (car y)) (apply min (cons (car y) (cdr y)))
                       (apply min (cons  x      (cdr y)))))))
(define max (lambda (x . y)
   (if (null? y) x
     (if (< x (car y)) (apply max (cons (car y) (cdr y)))
                       (apply max (cons  x      (cdr y)))))))

(define car-all (lambda (a) 
   (if (null? a) ()
       (cons (caar a) (car-all (cdr a))))))

(define cdr-all (lambda (a) 
   (if (null? a) ()
       (cons (cdar a) (cdr-all (cdr a))))))

(define map-1 (lambda (a)
    (cond 
       ((null? (car a)) ())
;;     ((null? (caar a)) ())  ;;  
       (#t (cons (car-all a) 
             (map-1 (cdr-all a)))))))

(define applys (lambda (f args)
   (if (null? args) ()
       (cons (apply f (car args)) (applys f (cdr args))))))

(define map (lambda (f . args)
    (applys f (map-1 args))))



(define for-each (lambda (f . args)
                   (for-each-1 f args)))

(define for-each-1 (lambda (f args)
  (if (null? (car args)) 
      '#<unspecified>
    (begin (apply f (car-all args)) (for-each-1 f (cdr-all args))))))

;(define (<= a b) (or (= a b) (< a b)))
;(define (>= a b) (or (= a b) (> a b)))
;(define (zero? x)
;    (if (= x 0) #t #f))
(define (1+ x) (+ x 1))
(define (1- x) (- x 1))

;(define (odd? x) (not (even? x)))
(define (bbbbb x) (or (eq? x #t)(eq? x #f)))

(define (exit) (bye))
(define (quit) (bye))

(define (print x . y)
      (display x)
      (if (not (null? y)) 
          (for-each (lambda (z) (display z)) y))
      (newline))

(if (gtea-installed?)        ; G-tea Ǥ뤫ɤȽꤹ
    (define (info-gtea)
	    (list (info-width) (info-direction) (info-color)
		  (info-pendown?) (info-speed) (info-position)))
)

(if (gtea-installed?)        ; G-tea Ǥ뤫ɤȽꤹ
    (define (help-gtea)
	    (help-logo)
	    (help-basic))
)

(if (gtea-installed?)        ; G-tea Ǥ뤫ɤȽꤹ
    (define (pencolor x)
	    (color x 7))
)    

(if (gtea-installed?)        ; G-tea Ǥ뤫ɤȽꤹ
    (begin (define black 0)
	   (define blue 1)
	   (define green 2)
	   (define pale 3)
	   (define red 4)
	   (define purple 5)
	   (define yellow 6)
	   (define white 7))
)

(define *count* 0)

;   (repeat 8 square-45)
 (define (repeat c func)
      (cond ((= c 0) 'end)
            (else (set! *count* c) (func) (repeat (- c 1) func))))

;  demo ϼ³
;  (forever demo)  demo ̵²󷫤֤ɾ
(define (forever exp)
   (exp)
   (forever exp))

;  
;  (forevers '(begin (proc1) ... (procn)))
;                     (proc1) ... (procn) ν̵²󷫤֤
;        (begin ...) ˤϥȤɬ (ʤаȤɾƤޤ)
(define (forevers exps)
     (do ()
	 (#f '())
         (eval exps)))

(display "include.sc  Ver.2.3 (2003)")
(newline)
;[eof]

